Attribute VB_Name = "ds"
'13.11.22 add multyselect and white color dimension
'20.11.22 add very small dimension

#If VBA7 Then
Private Declare PtrSafe Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
#Else
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
#End If

Option Explicit

    Public x#, y#, sx#, sy#, k#, qnt As Long, answer, MM As String
    Public pt1 As SnapPoint, pt2 As SnapPoint, Tline As Double
    Public s As Shape, s1 As Shape, ASR As ShapeRange, ArType As Long

Sub razmer_vydeleniya()

    Optimization = True: EventsEnabled = False
    ActiveDocument.SaveSettings
    ActiveDocument.BeginCommandGroup "Show_Size"
    ActiveDocument.Unit = cdrMillimeter
    ActiveDocument.ReferencePoint = cdrCenter
    
    If CtrlKey Then
        Set ASR = ActiveSelectionRange
        qnt = ASR.Count
        If qnt > 10 Then
        answer = MsgBox("Number of objects > 10" & vbNewLine & "Continue?", vbYesNo)
        If answer = vbNo Then GoTo oNo
        End If
            For Each s1 In ASR
            s1.CreateSelection
                Call Razmer
            Next s1
    Else
        Call Razmer
    End If
oNo:
If CtrlKey Then ASR.RemoveAll
    ActiveDocument.EndCommandGroup
    ActiveDocument.RestoreSettings
    EventsEnabled = True: Optimization = False
    ActiveDocument.ClearSelection
    ActiveWindow.Refresh: Application.Refresh

End Sub

Private Sub Razmer()

    ArType = 89: Tline = 0.2
    ActiveSelection.GetBoundingBox x, y, sx, sy
    
    If sx >= sy Then k = sx / 8
    If sy > sx Then k = sy / 8
    If k < 2 Then
        Tline = 0.1: k = 2: ArType = 88
    End If
    If sx < 3 Or sy < 3 Then
        Tline = 0.1: k = 1.5: ArType = 88
    End If

    Set pt1 = CreateSnapPoint(x, y + sy)
    Set pt2 = CreateSnapPoint(x + sx, y + sy)
    Set s = ActiveLayer.CreateLinearDimension(cdrDimensionHorizontal, pt1, pt2, True, , , cdrDimensionStyleDecimal, , , , , , , , , , , , , , k)
    s.Dimension.TextShape.SetPosition x + sx / 2, y + sy + (k / 2)
    ForceDimensionPrecision s, 1
    
    If k = 1.5 Then
    s.Dimension.TextShape.Outline.SetProperties 0.2, , , , , cdrTrue, cdrFalse, cdrOutlineRoundLineCaps, cdrOutlineRoundLineJoin, , , , , MiterLimit:=5#
    s.Dimension.TextShape.Outline.Color.CMYKAssign 0, 0, 0, 0
    End If
    
    s.Outline.SetProperties Tline, OutlineStyles(0), , ArrowHeads(ArType), ArrowHeads(ArType), _
    cdrFalse, cdrTrue, cdrOutlineButtLineCaps, cdrOutlineMiterLineJoin, 0#, 100, MiterLimit:=5#
If ShiftKey Then s.Outline.Color.CMYKAssign 0, 0, 0, 0
If ShiftKey Then
s.Dimension.TextShape.Fill.UniformColor.CMYKAssign 0, 0, 0, 0
    If k = 1.5 Then
    s.Dimension.TextShape.Outline.SetProperties 0.2, , , , , cdrTrue, cdrFalse, cdrOutlineRoundLineCaps, cdrOutlineRoundLineJoin, , , , , MiterLimit:=5#
    s.Dimension.TextShape.Outline.Color.CMYKAssign 80, 40, 0, 20
    End If
End If
    
    Set pt1 = CreateSnapPoint(x, y)
    Set pt2 = CreateSnapPoint(x, y + sy)
    Set s = ActiveLayer.CreateLinearDimension(cdrDimensionVertical, pt1, pt2, True, , , cdrDimensionStyleDecimal, , , , , , , , , , , , , , k)
    s.Dimension.TextShape.SetPosition x - (k / 2), y + sy / 2
    ForceDimensionPrecision s, 1
    
    If k = 1.5 Then
    s.Dimension.TextShape.Outline.SetProperties 0.2, , , , , cdrTrue, cdrFalse, cdrOutlineRoundLineCaps, cdrOutlineRoundLineJoin, , , , , MiterLimit:=5#
    s.Dimension.TextShape.Outline.Color.CMYKAssign 0, 0, 0, 0
    End If
    
    If k = 2 Then s.Dimension.Placement = cdrDimensionAboveLine
    s.Outline.SetProperties Tline, OutlineStyles(0), , ArrowHeads(ArType), ArrowHeads(ArType), _
    cdrFalse, cdrTrue, cdrOutlineButtLineCaps, cdrOutlineMiterLineJoin, 0#, 100, MiterLimit:=5#
If ShiftKey Then s.Outline.Color.CMYKAssign 0, 0, 0, 0
If ShiftKey Then
s.Dimension.TextShape.Fill.UniformColor.CMYKAssign 0, 0, 0, 0
    If k = 1.5 Then
    s.Dimension.TextShape.Outline.SetProperties 0.2, , , , , cdrTrue, cdrFalse, cdrOutlineRoundLineCaps, cdrOutlineRoundLineJoin, , , , , MiterLimit:=5#
    s.Dimension.TextShape.Outline.Color.CMYKAssign 80, 40, 0, 20
    End If
End If
End Sub

Private Sub ForceDimensionPrecision(ByVal s As Shape, ByVal precision As Integer)
    s.Style.GetProperty("dimension").SetProperty "precision", precision
End Sub

Function ShiftKey() As Boolean
    ShiftKey = (GetAsyncKeyState(vbKeyShift) And &H8000)
End Function

Function CtrlKey() As Boolean
    CtrlKey = (GetAsyncKeyState(vbKeyControl) And &H8000)
End Function
